#include <windows.h>
#include <mbstring.h>
#include <commctrl.h>
#include <process.h>
#include "setwin2.h"
#include "shellutil.h"
#include "gdiputil.h"
#include "resource.h"
#define MYWNDTITLE		"FileSearcher"
#define MYWNDCLASS		"FileSearcherClass"
#define MYCHILDWNDCLASS	"MyChildClass"
#define MENU_FIRSTVO	(WM_USER+201)		// VF j[̃R}hID̊JnԍiVOj
#define MENU_LASTVO		(WM_USER+600)		// VF j[̃R}hID̍ŏIԍiVOj
#define MENU_FIRSTNV	(WM_USER+601)		// VF j[̃R}hID̊JnԍiNVj
#define MENU_LASTNV		(WM_USER+1000)		// VF j[̃R}hID̍ŏIԍiNVj
#define IDM_SEARCH		(WM_USER+1001)
#define IDM_STOP		(WM_USER+1002)
#define IDM_FOLDER		(WM_USER+1003)
#define IDM_RENAME2		1643
#define ID_CHILD		1400
#define ID_EDIT			1401
#define ID_EDIT2		1402
#define ID_EDIT3		1403
#define ID_LIST			1404
#define TB_NUM			3	// c[{^̐
#define COL_NUM			5	// Xgr[̃J
#define LEN				256	// ̍ő咷
#define SEARCH_MAX		256	// t@C̏l
#define CHILDWND_HGT	70	// qEBhE̍
#define SAFE_RELEASE(p)			if (p){p->Release();p=NULL;}
#define	SAFE_DELETE_OBJ(p)		if (p){delete p;p=NULL;}
#define	SAFE_DELETE_ARRAY(p)	if (p){delete[]p;p=NULL;}

HWND		g_hWnd = NULL;
HWND		g_hChild = NULL;
HWND		g_hToolbar = NULL;
HWND		g_hEdit1 = NULL;
HWND		g_hEdit2 = NULL;
HWND		g_hEdit3 = NULL;
HWND		g_hCheck1 = NULL;
HWND		g_hCheck2 = NULL;
HWND		g_hComb = NULL;
HWND		g_hStatic1 = NULL;
HWND		g_hStatic2 = NULL;
HWND		g_hList = NULL;
HIMAGELIST	g_hIml = NULL;

// t@C
typedef struct{
	bool		bFolder;			// false:t@C, true:tH_
	DWORD		dwAttributes;		// t@C̏
	DWORD		dwFsize;			// t@CTCY
	FILETIME	ftTime;				// XViFILETIMEj
	SYSTEMTIME	stTime;				// XViSYSTEMTIMEj
	int			idxIcon;			// ACRԍ
	char		Fname[MAX_PATH];	// tpX
	char		Tname[80];			// t@C̎
}FILELIST1,*LPFILELIST1;

typedef struct{
	bool	bSearch;	// tO
	bool	bSearchEnd;	// ʕ\ptO
	bool	bStop;		// ~tO
	bool	bSubDir;	// qtH_[tO
	bool	bCapital;	// E̋ʃtO
	bool	bText;		// t@CeLXgtO
	char	str[LEN];	// 
	char	strExe[MAX_PATH];	// ftHg̎st@C
	int		idxColPre;	// 0 ȊOőOɉꂽJ̔ԍ
	int		numReflex;	// ċAJEg
	int		numItem;	// Xgr[̃ACe
	int		idxSelect;	// ݑIĂACe̔ԍ
}STRUCT1,*LPSTRUCT1;

STRUCT1	g_s;
int		g_iBmp[TB_NUM] = {STD_FIND, STD_DELETE, STD_FILEOPEN};
int		g_iCmd[TB_NUM] = {IDM_SEARCH, IDM_STOP, IDM_DIR};
char	g_sTxt[TB_NUM][24] = {"Jn", "~", "̫ް̑I"};
char	g_strRun[][24] = {"","","I"};
char	colText[COL_NUM][64] = {"t@C","","TCY","XV","pX"};
int		colWdh[COL_NUM] = {200,150,100,120,400};
int		colFmt[COL_NUM] = {0,0,1,0,0};

WNDPROC lpPreEditProc;	// {̃GfBbgRg[̃vV[W

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ProcChildWnd(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK ProcEdit(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
int     CALLBACK ProcListViewCompare(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
void	M_Open();
void	M_Open2();
void	M_OpenDef();
void	M_Folder();
void	M_Folder2();
void	M_Copy();
void	M_Delete();
void	M_Delete_Sub();
void	M_Rename();
void	M_Send_Desktop();
void	M_SellAll();
void	M_Search();
bool	M_Dir(HWND hWnd);
HRESULT	M_ContextMenu(LPCONTEXTMENU2 *ppCM2_VO, LPCONTEXTMENU2 *ppCM2_NV);
HRESULT	Set_Obj(REFIID riid, LPVOID *ppObj, LPITEMIDLIST *pidlFile, UINT uNum, bool bVO, bool *bAddNV);
void	Search(void *pv);
void	Search_End();
void	Add_Data(WIN32_FIND_DATA w32fd, char *filename_new, bool bFolder);
void	Add_One_Item(FILELIST1 fl);
void	Draw_Info1();
void	Draw_Info2();
bool	GetTiming(UINT speed, long *tick_count);
LPFILELIST1 Get_Lparam(int iItem);
int		CharCmp_Path_Up(LPFILELIST1 a, LPFILELIST1 b);
//int		CharCmp_Path_Down(LPFILELIST1 a, LPFILELIST1 b);
int		CharCmp_Name_Up(LPFILELIST1 a, LPFILELIST1 b);
//int		CharCmp_Name_Down(LPFILELIST1 a, LPFILELIST1 b);
int		CharCmp_Ext_Up(LPFILELIST1 a, LPFILELIST1 b);
//int		CharCmp_Ext_Down(LPFILELIST1 a, LPFILELIST1 b);
//int		CharCmp_Time_Up(LPFILELIST1 a, LPFILELIST1 b);
int		CharCmp_Time_Down(LPFILELIST1 a, LPFILELIST1 b);
int		CharCmp_Size_Up(LPFILELIST1 a, LPFILELIST1 b);
//int		CharCmp_Size_Down(LPFILELIST1 a, LPFILELIST1 b);
void	Init_Global();
void	Init();
void	Memory_AllFree();
void	Term();

class CDropSrc : public IDropSource
{
	ULONG m_nRefCount;

public:
	STDMETHODIMP QueryInterface(REFIID riid, LPVOID* ppv)
		{
			if(IsEqualIID(riid, IID_IUnknown)){
				*ppv = (LPUNKNOWN)(IDropSource*)this;
			}
			else if( IsEqualIID(riid, IID_IDropSource)){
				*ppv = (IDropSource*)this;
			}
			else{
				*ppv = NULL;
				return E_NOINTERFACE;
			}
			AddRef();
			return NOERROR;
		}                                             
	STDMETHODIMP_(DWORD) Release()
		{
			if(--m_nRefCount) return m_nRefCount;
			delete this;
			return 0;
		}
	STDMETHODIMP_(DWORD) AddRef()
		{
			return ++m_nRefCount;
		}
	HRESULT STDMETHODCALLTYPE QueryContinueDrag( 
			BOOL fEscapePressed,
			DWORD grfKeyState)
		{
			if(fEscapePressed)
				return DRAGDROP_S_CANCEL;
			else if(!(grfKeyState & MK_LBUTTON))
				return DRAGDROP_S_DROP;
			else
				return NOERROR;
		}
	HRESULT STDMETHODCALLTYPE GiveFeedback(DWORD dwEffect)
		{
			return DRAGDROP_S_USEDEFAULTCURSORS;
		}
};

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	HACCEL hAC = LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACCELERATOR1));
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1)),
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		if(TranslateAccelerator(hWnd, hAC, &msg) && (g_hList == GetFocus())){
            continue;
        }
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// eEBhE vV[W
LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static LPCONTEXTMENU2 pCM2_VO = NULL;
	static LPCONTEXTMENU2 pCM2_NV = NULL;
	
	switch (uMsg)
	{
	case WM_CREATE:
		// EBhE nhOϐɃRs[
		g_hWnd = hWnd;
		// 
		Init();
		return 0;
	case WM_SIZE:
		if(g_hToolbar && g_hChild && hWnd && g_hList){
			RECT rc,rc_t;
			SendMessage(g_hToolbar, WM_SIZE, 0, 0);
			GetWindowRect(g_hToolbar, &rc_t);
			GetClientRect(hWnd, &rc);
			// qEBhẼTCYύX
			MoveWindow(g_hChild, 0, rc_t.bottom-rc_t.top, rc.right, CHILDWND_HGT, TRUE);
			// Xgr[̃TCYύX
			MoveWindow(g_hList, 0, rc_t.bottom-rc_t.top+CHILDWND_HGT,
						rc.right, rc.bottom-((rc_t.bottom-rc_t.top)+CHILDWND_HGT), TRUE);
		}
		return 0;
	case WM_INITMENUPOPUP:
		if(pCM2_VO){
			pCM2_VO->HandleMenuMsg(uMsg, wParam, lParam);
		}
		if(pCM2_NV){
			pCM2_NV->HandleMenuMsg(uMsg, wParam, lParam);
		}
		return FALSE;
	case WM_DRAWITEM:
	case WM_MEASUREITEM:
		if(pCM2_VO){
			pCM2_VO->HandleMenuMsg(uMsg, wParam, lParam);
		}
		if(pCM2_NV){
			pCM2_NV->HandleMenuMsg(uMsg, wParam, lParam);
		}
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_EXIT:		// I
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		case IDM_OPEN:		// J
			M_Open2();
			return 0;
		case IDM_OPENDEF:	// ftHg AvP[VJ
			M_OpenDef();
			return 0;
		case IDM_FOLDER:	// tH_[JitH[JX ACê݁j
			M_Folder();
			return 0;
		case IDM_FOLDER2:	// tH_[JiIĂ鑍ẴACej
			M_Folder2();
			return 0;
		case IDM_COPY:		// Rs[
			M_Copy();
			return 0;
		case IDM_DELETE:	// 폜
			M_Delete();
			return 0;
		case IDM_RENAME:	// O̕ύX
		case IDM_RENAME2:
			M_Rename();
			return 0;
		case IDM_SEND_DESKTOP:	// fXNgbvɃV[gJbg쐬
			M_Send_Desktop();
			return 0;
		case IDM_SELALL:	// đI
			M_SellAll();
			return 0;
		case IDM_SEARCH:	// 
			M_Search();
			return 0;
		case IDM_DIR:		// tH_[̎w
			M_Dir(hWnd);
			return 0;
		case IDM_STOP:		// ~
			g_s.bStop = true;
			return 0;
		case IDM_SORT_NAME:	// t@Cŕёւ
			ListView_SortItems(g_hList,ProcListViewCompare,0);
			return 0;
		case IDM_SORT_EXT:	// ނŕёւ
			ListView_SortItems(g_hList,ProcListViewCompare,1);
			return 0;
		case IDM_SORT_SIZE:	// t@CTCYŕёւ
			ListView_SortItems(g_hList,ProcListViewCompare,2);
			return 0;
		case IDM_SORT_TIME:	// XVŕёւ
			ListView_SortItems(g_hList,ProcListViewCompare,3);
			return 0;
		case IDM_SORT_PATH:	// pXŕёւ
			ListView_SortItems(g_hList,ProcListViewCompare,4);
			return 0;
		}
		return 0;
	case WM_NOTIFY:
		switch(wParam)
		{
		case ID_LIST:
			{
				NMHDR *phdr = (NMHDR*) lParam;
				switch(phdr->code)
				{
				case LVN_BEGINLABELEDIT:// xύXJn
					return FALSE;
				case LVN_ENDLABELEDIT:	// xύXI
					if(phdr->hwndFrom == g_hList){
						NMLVDISPINFO *pdi = (NMLVDISPINFO*) phdr;
						if(pdi){
							if(pdi->item.iItem == -1 || !pdi->item.pszText || !strcmp(pdi->item.pszText,"")){
								return FALSE;
							}
							if(pdi->item.mask & LVIF_TEXT){
								LPFILELIST1 pfl = Get_Lparam(pdi->item.iItem);
								if(pfl){
									char new_name[MAX_PATH];
									strncpy(new_name, pfl->Fname, sizeof(new_name));
									char *p = (char*) _mbsrchr((UCHAR*)new_name, (UINT)'\\');
									if(p+1){
										strcpy(p+1, (char*) pdi->item.pszText);
									}
									SHFILEOPSTRUCT	sfo;
									ZeroMemory(&sfo, sizeof(sfo));
									sfo.hwnd	= g_hWnd;
									sfo.wFunc	= FO_RENAME;
									sfo.pFrom	= pfl->Fname;
									sfo.pTo		= new_name;
									sfo.fFlags	= FOF_FILESONLY;
									int res = SHFileOperation(&sfo);
									if(res){	// ̏ꍇ 0 Ԃ
										return FALSE;
									}
									ListView_SetItemText(g_hList,pdi->item.iItem,0,pdi->item.pszText);
									strncpy(pfl->Fname, new_name, sizeof(pfl->Fname));
								}
							}
						}
					}
					return TRUE;
				case LVN_COLUMNCLICK:	// JNbNꂽ
					if(phdr->hwndFrom == g_hList){
						LPNMLISTVIEW pnmlv = (LPNMLISTVIEW) lParam;
						LPFILELIST1 pfl1 = Get_Lparam(g_s.idxSelect);
						char fname[MAX_PATH] = "";
						if(pfl1){
							strncpy(fname, pfl1->Fname, sizeof(fname));
						}
						// ёւ
						ListView_SortItems(g_hList,ProcListViewCompare,(LPARAM)(pnmlv->iSubItem));
						// IACeԍ̐ݒ
						if(strcmp(fname, "")){
							for(int i=0;i<g_s.numItem;i++){
								LPFILELIST1 pfl2 = Get_Lparam(i);
								if(pfl2){
									if(!strcmp(pfl2->Fname, fname)){
										g_s.idxSelect = i;
										break;
									}
								}
							}
						}
					}
					break;
				case LVN_ITEMCHANGED:	// ACȇIς
					if(phdr->hwndFrom == g_hList){
						LPNMLISTVIEW pnmlv = (LPNMLISTVIEW) lParam;
						g_s.idxSelect = pnmlv->iItem;
						char filename[MAX_PATH];
						ListView_GetItemText(g_hList, pnmlv->iItem, 4, filename, sizeof(filename));
						SendMessage(g_hEdit3, WM_SETTEXT, 0, (LPARAM) filename);
						RECT rc;
						SetRect(&rc, 0, 0, CHILDWND_HGT, CHILDWND_HGT);
						InvalidateRect(g_hChild, &rc, TRUE);
					}
					break;
				case NM_DBLCLK:			// _uNbN
					M_Open();
					break;
				case NM_RCLICK:			// ENbN
					if(phdr->hwndFrom == g_hList){
						M_ContextMenu(&pCM2_VO, &pCM2_NV);
					}
					break;
				case LVN_BEGINDRAG: 	//	hbOJn
					{
						LPMALLOC		pMalloc = NULL;
						LPITEMIDLIST	*pidlFileNV = NULL;
						LPDATAOBJECT	pDO = NULL;	
						UINT			uNum;
						
						SHGetMalloc(&pMalloc);
						uNum = ListView_GetSelectedCount(g_hList);
						pidlFileNV = (LPITEMIDLIST*) pMalloc->Alloc(uNum * sizeof(LPITEMIDLIST));
						bool bAddNV = false;
						Set_Obj(IID_IDataObject, (LPVOID*) &pDO, pidlFileNV, uNum, false, &bAddNV);
						if(pDO){
							CDropSrc	*pDS = new CDropSrc();
							DWORD		dwEffect;
							DoDragDrop(pDO, (IDropSource*) pDS, DROPEFFECT_COPY, &dwEffect);
							SAFE_RELEASE(pDO);
							SAFE_RELEASE(pDS);
						}
						if(pidlFileNV)
							pMalloc->Free(pidlFileNV);
						SAFE_RELEASE(pMalloc);
					}
					break;
				}
			}
			break;
		default:
			{
				NMHDR *phdr = (NMHDR*) lParam;
				switch(phdr->code)
				{
				case TTN_NEEDTEXT:		// c[qg
					LPTOOLTIPTEXT lpttText;
					lpttText = (LPTOOLTIPTEXT)lParam;
					for(int i=0;i<sizeof(g_iCmd)/sizeof(int);i++){
						if((int)lpttText->hdr.idFrom == g_iCmd[i]){
							lpttText->lpszText = g_sTxt[i];
							break;
						}
					}
					break;
				}
			}
			break;
		}
		return 0;
	case WM_CLOSE:
		Term();
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

// qEBhE vV[W
LRESULT CALLBACK ProcChildWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND hStatic[2] = {NULL, NULL};
	
	switch (uMsg)
	{
	case WM_CREATE:
		{
			// X^eBbN Rg[̍쐬
			char str1[] = "tH_[";
			CSIZE	csz_s1,csz_s2,csz_s3,csz_s4,csz_e1,csz_e2;
			SIZE	sz1;
			int		offset_x1 = CHILDWND_HGT + 5;
			sz1 = Get_StrSize(hWnd, str1);
			csz_s1 = Set_Csize(offset_x1, 5, 80, sz1.cy);
			hStatic[0] = Set_Static2(hWnd, csz_s1, str1, DEFAULT_GUI_FONT);
			csz_s2 = Set_Csize(offset_x1, sz1.cy + 8, 80, sz1.cy);
			g_hStatic1 = Set_Static2(hWnd, csz_s2, "", DEFAULT_GUI_FONT);
			csz_s3 = Set_Csize(offset_x1, sz1.cy * 2 + 11, 80, sz1.cy);
			hStatic[1] = Set_Static2(hWnd, csz_s3, "pX", DEFAULT_GUI_FONT);
			RECT rc_s1;
			GetWindowRect(hStatic[0], &rc_s1);
			int		offset_x2 = offset_x1 + rc_s1.right - rc_s1.left + 10;
			csz_s4 = Set_Csize(offset_x2, sz1.cy + 8, 100, sz1.cy);
			g_hStatic2 = Set_Static2(hWnd, csz_s4, "", DEFAULT_GUI_FONT);
			// GfBbg{bNX̍쐬
			csz_e1 = Set_Csize(offset_x2, 5, 800, sz1.cy);
			g_hEdit2 = Set_Edit(hWnd, csz_e1, ID_EDIT2, ES_LEFT | ES_AUTOHSCROLL | ES_READONLY, NULL);
			csz_e2 = Set_Csize(offset_x2, csz_s3.y, 800, sz1.cy);
			g_hEdit3 = Set_Edit(hWnd, csz_e2, ID_EDIT3, ES_LEFT | ES_AUTOHSCROLL | ES_READONLY, NULL);
			// GDIPLUS ̏
			Init_Gdip();
		}
		return 0;
	case WM_PAINT:
		{
			HDC				hDC;
			PAINTSTRUCT 	ps;
			hDC = BeginPaint(hWnd,&ps);
			LPFILELIST1 pfl = Get_Lparam(g_s.idxSelect);
			if(pfl && !Draw_Image(hWnd, hDC, pfl->Fname)){
				SHFILEINFO sfi;
				if(SHGetFileInfo(pfl->Fname, 0, &sfi, sizeof(sfi), SHGFI_ICON | SHGFI_LARGEICON)){
					POINT		pos;
					pos.x = (CHILDWND_HGT - GetSystemMetrics(SM_CXICON)) / 2;
					pos.y = (CHILDWND_HGT - GetSystemMetrics(SM_CYICON)) / 2;
					DrawIcon(hDC, pos.x, pos.y, sfi.hIcon);
					DestroyIcon(sfi.hIcon);
				}
			}
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		// GDIPLUS ̏I
		Term_Gdip();
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcChildWnd

// GfBbg Rg[̃tbN vV[W
LRESULT CALLBACK ProcEdit(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static bool flag_sel = false;
	
	switch ( uMsg )
	{
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_RETURN:
			if(!(lParam & 0x40000000)){	// s[gł͂Ȃꍇ
				M_Search();
			}
			break;
		}
		break;
	case WM_MOUSEMOVE:
		{
			DWORD	start,end;
			SendMessage(hWnd, EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
			flag_sel = false;
			if((end - start) > 0){
				flag_sel = true;
			}
		}
		break;
	case WM_LBUTTONUP:
		if(!flag_sel){
			SendMessage(hWnd, EM_SETSEL, 0, -1);
		}
		break;
	case WM_KILLFOCUS:
		SendMessage(hWnd, EM_SETSEL, 0, 0);
		break;
	}
	// SẴbZ[W{̃vV[W֑i~@\͑Ȃj
	return CallWindowProc(lpPreEditProc,hWnd,uMsg,wParam,lParam);
}// ProcEdit

// J̃NbNŃ\[gƂ̃\[g̃[
int CALLBACK ProcListViewCompare(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	LPFILELIST1	pfl1 = (LPFILELIST1)lParam1;
	LPFILELIST1	pfl2 = (LPFILELIST1)lParam2;
	int			iResult = 0;
	
	if (pfl1 && pfl2)
	{
		switch(lParamSort)
		{
		case 0:	// t@C
			iResult = CharCmp_Name_Up(pfl1, pfl2);
			break;
		case 1:	// gq
			iResult = CharCmp_Ext_Up(pfl1, pfl2);
			break;
		case 2:	// t@CTCY
			iResult = CharCmp_Size_Up(pfl1, pfl2);
			break;
		case 3:	// XV
			iResult = CharCmp_Time_Down(pfl1, pfl2);
			break;
		case 4:	// pX
			iResult = CharCmp_Path_Up(pfl1, pfl2);
			break;
		}
	}
	if(iResult == 0){
		if(lParamSort > 0){
			iResult = CharCmp_Name_Up(pfl1, pfl2);
		}
		else{
			switch(g_s.idxColPre)
			{
			case 1:	// gq
				iResult = CharCmp_Ext_Up(pfl1, pfl2);
				break;
			case 2:	// t@CTCY
				iResult = CharCmp_Size_Up(pfl1, pfl2);
				break;
			case 3:	// XV
				iResult = CharCmp_Time_Down(pfl1, pfl2);
				break;
			case 4:	// pX
				iResult = CharCmp_Path_Up(pfl1, pfl2);
				break;
			}
		}
	}
	if(lParamSort > 0){
		g_s.idxColPre = lParamSort;
	}
	return(iResult);
}// ProcListViewCompare

void M_Open()
{
	if(g_s.idxSelect >= 0){
		LPFILELIST1 pfl = Get_Lparam(g_s.idxSelect);
		if(pfl){
			HINSTANCE hResult = ShellExecute(NULL, "open", pfl->Fname, "", "", SW_SHOW);
			if(hResult <= (HINSTANCE) 32){
				ShellExecute(NULL, "open", g_s.strExe, pfl->Fname, "", SW_SHOW);
			}
		}
	}
}// M_Open

void M_Open2()
{
	for(int i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl){
				HINSTANCE hResult = ShellExecute(NULL, "open", pfl->Fname, "", "", SW_SHOW);
				if(hResult <= (HINSTANCE) 32){
					ShellExecute(NULL, "open", g_s.strExe, pfl->Fname, "", SW_SHOW);
				}
			}
		}
	}
}// M_Open2

void M_OpenDef()
{
	for(int i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl && !pfl->bFolder){	// tH_[ł͂Ȃꍇ
				ShellExecute(NULL, "open", g_s.strExe, pfl->Fname, "", SW_SHOW);
			}
		}
	}
}// M_OpenDef

void M_Folder()
{
	if(g_s.idxSelect >= 0){
		char path[MAX_PATH];
		LPFILELIST1 pfl = Get_Lparam(g_s.idxSelect);
		if(pfl){
			strncpy(path, pfl->Fname, sizeof(path));
			if(!pfl->bFolder){	// tH_[ł͂Ȃꍇ
				char *p = (char*) _mbsrchr((UCHAR*)path, (UINT)'\\');
				if(p){
					strcpy(p, "");
				}
			}
			ShellExecute(NULL, NULL, path, NULL, NULL, SW_SHOWNORMAL);
		}
	}
}// M_Folder

void M_Folder2()
{
	for(int i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl){
				char path[MAX_PATH];
				strncpy(path, pfl->Fname, sizeof(path));
				if(!pfl->bFolder){	// tH_[ł͂Ȃꍇ
					char *p = (char*) _mbsrchr((UCHAR*)path, (UINT)'\\');
					if(p){
						strcpy(p, "");
					}
				}
				ShellExecute(NULL, NULL, path, NULL, NULL, SW_SHOWNORMAL);
			}
		}
	}
}// M_Folder2

void M_Copy()
{
	HANDLE		hMem = NULL;
	DROPFILES	df;
	LPBYTE		pBuf = NULL;
	int			i;
	
	ZeroMemory(&df, sizeof(df));
	df.pFiles = sizeof(df);
	df.fWide = 0;
	if(OpenClipboard(NULL)){
		EmptyClipboard();
		int size;
		size = sizeof(df) + 1;
		for(i=0;i<g_s.numItem;i++){
			UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
			if(flag & LVIS_SELECTED){
				LPFILELIST1 pfl = Get_Lparam(i);
				if(pfl && GetFileAttributes(pfl->Fname) != -1){
					size += (strlen(pfl->Fname) + 1);
				}
			}
		}
		hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, size);
		pBuf = (LPBYTE) GlobalLock(hMem);
		memcpy(pBuf, &df, sizeof(df));
		int offset = sizeof(df);
		for(i=0;i<g_s.numItem;i++){
			UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
			if(flag & LVIS_SELECTED){
				LPFILELIST1 pfl = Get_Lparam(i);
				if(pfl && GetFileAttributes(pfl->Fname) != -1){
					memcpy(pBuf + offset, pfl->Fname, strlen(pfl->Fname) + 1);
					offset += (strlen(pfl->Fname) + 1);
				}
			}
		}
		memcpy(pBuf + offset, "", 1);
		SetClipboardData(CF_HDROP, hMem);
		GlobalUnlock(hMem);
		CloseClipboard();
	}
}// M_Copy

void M_Delete()
{
	if(g_hList != GetFocus()){
		return;
	}
	
	int		i,size;
	char	*pFname = NULL;
	
	size = 1;
	for(i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl){
				size += (strlen(pfl->Fname) + 1);
			}
		}
	}
	if(size == 1){
		return;
	}
	pFname = new char [size];
	ZeroMemory(pFname, size);
	int offset = 0;
	for(i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl){
				memcpy(pFname + offset, pfl->Fname, strlen(pfl->Fname) + 1);
				offset += (strlen(pfl->Fname) + 1);
			}
		}
	}
	SHFILEOPSTRUCT	sfo;
	ZeroMemory(&sfo, sizeof(sfo));
	sfo.hwnd	= g_hWnd;
	sfo.wFunc	= FO_DELETE;
	sfo.pFrom	= pFname;
	sfo.fFlags	= FOF_ALLOWUNDO | FOF_FILESONLY;
	int res = SHFileOperation(&sfo);
	SAFE_DELETE_ARRAY(pFname);
	// Xgr[ACe폜
	if(!res){
		M_Delete_Sub();
	}
}// M_Delete

// Xgr[ACe폜
void M_Delete_Sub()
{
	for(int i=g_s.numItem-1;i>=0;i--){
		LPFILELIST1 pfl = Get_Lparam(i);
		if(pfl && GetFileAttributes(pfl->Fname) == -1){
			SAFE_DELETE_OBJ(pfl);
			ListView_DeleteItem(g_hList, i);
		}
	}
	g_s.numItem = ListView_GetItemCount(g_hList);
	Draw_Info2();
}// M_Delete_Sub

void M_Rename()
{
	if(g_s.idxSelect >= 0){
		ListView_EditLabel(g_hList, g_s.idxSelect);
	}
}// M_Rename

void M_Send_Desktop()
{
	for(int i=0;i<g_s.numItem;i++){
		UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
		if(flag & LVIS_SELECTED){
			LPFILELIST1 pfl = Get_Lparam(i);
			if(pfl && GetFileAttributes(pfl->Fname) != -1){
				Create_ShortcutOnDesktop(pfl->Fname);
			}
		}
	}
}// M_Send_Desktop

void M_SellAll()
{
	for(int i=0;i<g_s.numItem;i++){
		ListView_SetItemState(g_hList, i, LVIS_SELECTED, LVIS_SELECTED);
	}
}// M_SellAll

void M_Search()
{
	if(!g_s.bSearch){
		g_s.bSearch = true;
		g_s.bSearchEnd = true;
		g_s.bStop = false;
		g_s.bSubDir = false;
		if(BST_CHECKED == SendMessage(g_hCheck1, BM_GETCHECK, 0, 0)){
			g_s.bSubDir = true;
		}
		g_s.bCapital = false;
		if(BST_CHECKED == SendMessage(g_hCheck2, BM_GETCHECK, 0, 0)){
			g_s.bCapital = true;
		}
		g_s.bText = false;
		if(1 == SendMessage(g_hComb, CB_GETCURSEL, 0, 0)){
			g_s.bText = true;
		}
		Draw_Info1();
		SendMessage(g_hEdit1, WM_GETTEXT, sizeof(g_s.str), (LPARAM) g_s.str);
		if(g_hList){
			Memory_AllFree();
			ListView_DeleteAllItems(g_hList);
		}
		g_s.numItem = 0;
		g_s.numReflex = 0;
		static char path[MAX_PATH];
		strncpy(path, g_path, sizeof(path));
		Draw_Info2();
		_beginthread(Search, 0, path);
	}
}// M_Search

bool M_Dir(HWND hWnd)
{
	bool flag = false;
	if(!g_s.bSearch){
		flag = Set_Dir(hWnd);
		if(flag){
			if(g_hIml){
				ImageList_Destroy(g_hIml);
			}
			SHFILEINFO sfi;
			g_hIml = (HIMAGELIST) SHGetFileInfo(g_path,
												0,
												&sfi,
												sizeof(SHFILEINFO),
												SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
			if(g_hList){
				Memory_AllFree();
				ListView_DeleteAllItems(g_hList);
				ListView_SetImageList(g_hList, g_hIml, LVSIL_SMALL);
			}
			g_s.numItem = 0;
			g_s.bSearchEnd = false;
			Draw_Info1();
			Draw_Info2();
		}
		SetFocus(g_hEdit1);
	}
	return flag;
}// M_Dir

HRESULT M_ContextMenu(LPCONTEXTMENU2 *ppCM2_VO, LPCONTEXTMENU2 *ppCM2_NV)
{
	HRESULT	hr = ERROR;
	
	if(g_s.idxSelect < 0){
		return hr;
	}
	// |bvAbvj[̍쐬
	HMENU hMenu = CreatePopupMenu();
	if(hMenu){
		LPMALLOC		pMalloc = NULL;
		LPITEMIDLIST	*pidlFileVO = NULL,*pidlFileNV = NULL;
		UINT			uNum;
		
		hr = SHGetMalloc(&pMalloc);
		// IContextMenu2 IuWFNg̎擾
		bool bAddNV = false;
		uNum = 1;
		pidlFileVO = (LPITEMIDLIST*) pMalloc->Alloc(1 * sizeof(LPITEMIDLIST));
		Set_Obj(IID_IContextMenu, (LPVOID*) ppCM2_VO, pidlFileVO, uNum, true, &bAddNV);
		uNum = ListView_GetSelectedCount(g_hList);
		pidlFileNV = (LPITEMIDLIST*) pMalloc->Alloc(uNum * sizeof(LPITEMIDLIST));
		Set_Obj(IID_IContextMenu, (LPVOID*) ppCM2_NV, pidlFileNV, uNum, false, &bAddNV);
		if((*ppCM2_VO) && (*ppCM2_NV)){
			// j[ɃACeǉ
			ShowCursor(FALSE);
			hr = (*ppCM2_NV)->QueryContextMenu(hMenu, 0, MENU_FIRSTNV, MENU_LASTNV, CMF_CANRENAME);
			if(bAddNV){
				RemoveMenu(hMenu, 0, MF_BYPOSITION);
				RemoveMenu(hMenu, 0, MF_BYPOSITION);
				hr = (*ppCM2_VO)->QueryContextMenu(hMenu, 0, MENU_FIRSTVO, MENU_LASTVO, CMF_VERBSONLY);
			}
			ShowCursor(TRUE);
			if(hr != NOERROR){
//				char buf[256] = "";
//				itoa(HRESULT_CODE(hr),buf,10);	// Ō̃R}hIDɂPZlԂ
//				SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)buf);
//				char szErrorDesc[400] = "";
//				FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL), szErrorDesc, sizeof(szErrorDesc), NULL);
//				SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)szErrorDesc);
				// j[[tH_[J]ǉ
				LPFILELIST1 pfl = Get_Lparam(g_s.idxSelect);
				if(pfl && stricmp(pfl->Fname+strlen(pfl->Fname)-4, ".lnk")){
					Menu_Add_Item(hMenu, IDM_FOLDER, "tH_[J(&I)", 1);
				}
				// |bvAbvj[̕\
				POINT pt;
				GetCursorPos(&pt);
				UINT  uCommand = TrackPopupMenu(hMenu, TPM_LEFTALIGN | TPM_RETURNCMD, pt.x, pt.y, 0, g_hWnd, NULL);
				if(uCommand > 0){
//					char buf[256] = "";
//					itoa(uCommand,buf,10);
//					SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)buf);
					if(uCommand == IDM_RENAME2){
						SendMessage(g_hWnd, WM_COMMAND, uCommand, 0);
					}
					else if(uCommand >= MENU_FIRSTVO && uCommand <= MENU_LASTVO){
						CMINVOKECOMMANDINFO cmi;
						ZeroMemory(&cmi, sizeof(cmi));
						cmi.cbSize = sizeof(cmi);
						cmi.hwnd   = g_hWnd;
						cmi.lpVerb = MAKEINTRESOURCE(uCommand - MENU_FIRSTVO);
						cmi.nShow  = SW_SHOWNORMAL;
						(*ppCM2_VO)->InvokeCommand(&cmi);
					}
					else if(uCommand >= MENU_FIRSTNV && uCommand <= MENU_LASTNV){
						CMINVOKECOMMANDINFO cmi;
						ZeroMemory(&cmi, sizeof(cmi));
						cmi.cbSize = sizeof(cmi);
						cmi.hwnd   = g_hWnd;
						cmi.lpVerb = MAKEINTRESOURCE(uCommand - MENU_FIRSTNV);
						cmi.nShow  = SW_SHOWNORMAL;
						(*ppCM2_NV)->InvokeCommand(&cmi);
						M_Delete_Sub();
					}
					else{
						SendMessage(g_hWnd, WM_COMMAND, uCommand, 0);
					}
				}
			}
			SAFE_RELEASE((*ppCM2_VO));
			SAFE_RELEASE((*ppCM2_NV));
		}
		DestroyMenu(hMenu);
		if(pidlFileVO)
			pMalloc->Free(pidlFileVO);
		if(pidlFileNV)
			pMalloc->Free(pidlFileNV);
		SAFE_RELEASE(pMalloc);
	}
	return hr;
}// M_ContextMenu

// IContextMenu2 ܂ IDataObject C^[tFCX̎擾
// riid		: [IN]  vꂽC^[tFCX̎QƎʎq
// ppObj	: [OUT] 󂯎C^[tFCX
// pidlFile	: [OUT] 󂯎 ITEMIDLIST \
// uNum		: [IN]  IACe
// bVO		: [IN]  true  VO, false  NV
// bAddNV	: [OUT] NV j[ɓꍇ́Atrue
HRESULT Set_Obj(REFIID riid, LPVOID *ppObj, LPITEMIDLIST *pidlFile, UINT uNum, bool bVO, bool *bAddNV)
{
	HRESULT			hr = ERROR;
	LPSHELLFOLDER	pSH = NULL;
	LPSHELLFOLDER	pSH2 = NULL;
	
	if(g_s.idxSelect < 0 || !(*pidlFile)){
		return hr;
	}
	
	hr = SHGetDesktopFolder(&pSH);
	if(pSH){
		LPITEMIDLIST	pidlRoot;
		WCHAR			wPath[MAX_PATH],wFname[MAX_PATH];
		char			path[MAX_PATH] = "", fname[MAX_PATH] = "";
		ULONG			chEaten;
		if(bVO){
			LPFILELIST1 pfl = Get_Lparam(g_s.idxSelect);
			if(pfl){
				strncpy(path, pfl->Fname, sizeof(path));
				char *p1 = (char*) _mbsrchr((UCHAR*)path, (UINT)'\\');
				if(p1){
					strncpy(fname, p1+1, sizeof(fname));
					strcpy(p1, "");
				}
			}
		}
		else{
			strncpy(path, g_path, sizeof(path));
		}
		if(path[strlen(path)-1] == '\\'){
			strcpy(&path[strlen(path)-1], "");
		}
		MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, path, -1, wPath, MAX_PATH);
		// tH_[PIDL擾
		hr = pSH->ParseDisplayName(g_hWnd, NULL, wPath, &chEaten, &pidlRoot, NULL);
		// tH_[IShellFolderIuWFNg擾
		hr = pSH->BindToObject(pidlRoot, NULL, IID_IShellFolder, (LPVOID*) &pSH2);
		SAFE_RELEASE(pSH);
		if(pSH2){
			// t@CPIDL擾
			if(bVO){
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, fname, -1, wFname, MAX_PATH);
				hr = pSH2->ParseDisplayName(g_hWnd, NULL, wFname, &chEaten, pidlFile, NULL);
			}
			else{
				UINT	ct = 0;
				int		idx = 0;
				int		len = strlen(path);
				*bAddNV = true;
				for(int i=0;i<g_s.numItem;i++){
					UINT flag = ListView_GetItemState(g_hList, i, LVIS_SELECTED);
					if(flag & LVIS_SELECTED){
						idx = i;
						LPFILELIST1 pfl = Get_Lparam(i);
						if(pfl){
							MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, ((pfl->Fname)+len+1), -1, wFname, MAX_PATH);
							hr = pSH2->ParseDisplayName(g_hWnd, NULL, wFname, &chEaten, &pidlFile[ct ++], NULL);
							if(uNum == 1){
								char *p = (char*) _mbsrchr((UCHAR*)((pfl->Fname)+len+1), (UINT)'\\');
								if(!p){
									*bAddNV = false;
								}
							}
						}
					}
				}
			}
			if(riid == IID_IDataObject){
				hr = pSH2->GetUIObjectOf(g_hWnd,
									uNum,
									(LPCITEMIDLIST*) pidlFile,
									riid,
									NULL,
									(LPVOID*) ppObj);
				SAFE_RELEASE(pSH2);
			}
			else{	// t@CIContextMenu擾
				LPCONTEXTMENU	pCM = NULL;
				hr = pSH2->GetUIObjectOf(g_hWnd,
									uNum,
									(LPCITEMIDLIST*) pidlFile,
									riid,
									NULL,
									(LPVOID*) &pCM);
				SAFE_RELEASE(pSH2);
				if(pCM){
					// IContextMenu2擾
					hr = pCM->QueryInterface(IID_IContextMenu2, (LPVOID*) ppObj);
					SAFE_RELEASE(pCM);
				}
			}
		}
	}
	return hr;
}// Set_Obj

// 
void Search(void *pv)
{
	HANDLE			hfind;
	WIN32_FIND_DATA w32fd;
	char			filename_find[MAX_PATH],filename_new[MAX_PATH];
	char			*path = (char *) pv;
	
	// pX̐
	if(!strlen(path)){
		g_s.bSearch = false;
		Draw_Info1();
		return;
	}
	// ͕̐
	if(!strlen(g_s.str)){
		g_s.bSearch = false;
		Draw_Info1();
		return;
	}
	if(!g_s.bCapital){
		_mbslwr((UCHAR*) g_s.str);
	}
	// ċAJEg̉Z
	g_s.numReflex ++;
	if(g_s.bStop){
		goto STOP;
	}
	// t@Č
	if(path[strlen(path)-1] == '\\'){
		path[strlen(path)-1] = '\0';
	}
	_snprintf(filename_find,sizeof(filename_find)-1,"%s\\*",path);
	hfind = FindFirstFile(filename_find, &w32fd);
	if(hfind != INVALID_HANDLE_VALUE){
		do{
			_snprintf(filename_new,sizeof(filename_new)-1,"%s\\%s",path,w32fd.cFileName);
			static long	TickCount = GetTickCount();
			bool		flagGo = GetTiming(100, &TickCount);
			if(flagGo){
				SendMessage(g_hEdit3, WM_SETTEXT, 0, (LPARAM) filename_new);
			}
			DWORD flag = w32fd.dwFileAttributes;
			if(g_s.bStop){
				break;
			}
			if(((flag & FILE_ATTRIBUTE_COMPRESSED)
				|| (flag & FILE_ATTRIBUTE_SYSTEM)
				|| (flag & FILE_ATTRIBUTE_HIDDEN))
				&& (g_s.bText || stricmp(w32fd.cFileName, "Thumbs.db")))
			{
				continue;
			}
			if(!strcmp(w32fd.cFileName, ".") || !strcmp(w32fd.cFileName, "..")){
				continue;
			}
			if(!g_s.bCapital){
				_mbslwr((UCHAR*) w32fd.cFileName);
			}
			if(flag & FILE_ATTRIBUTE_DIRECTORY)
			{
				if(strcmp(w32fd.cFileName, ".") && strcmp(w32fd.cFileName, "..")){
					// t@CitH_[j
					if(!g_s.bText){
						if(strstr(w32fd.cFileName, g_s.str)){
							Add_Data(w32fd, filename_new, true);
						}
					}
					// TutH_[̌
					if(g_s.bSubDir)
						Search(filename_new);
				}
			}
			if(((flag & FILE_ATTRIBUTE_COMPRESSED)
				|| (flag & FILE_ATTRIBUTE_DIRECTORY)
				|| (flag & FILE_ATTRIBUTE_SYSTEM)
				|| (flag & FILE_ATTRIBUTE_HIDDEN))
				&& (g_s.bText || stricmp(w32fd.cFileName, "Thumbs.db")))
			{
				continue;
			}
			if(!g_s.bText){	// t@Cit@Cj
				if(strstr(w32fd.cFileName, g_s.str)){
					Add_Data(w32fd, filename_new, false);
				}
			}
			else{			// t@CeLXǧ
				// t@C̓ǂݍ
				HANDLE	hFile;
				DWORD	dwRead;
				hFile = CreateFile(filename_new,GENERIC_READ,FILE_SHARE_READ,
									NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				if(hFile != INVALID_HANDLE_VALUE){
					long size = GetFileSize(hFile, NULL);	// size, len, char_ct ͕Ktɂ
					if(size > 0 && size != 0xFFFFFFFF){
						char *buf = new char [size + 1];
						ReadFile(hFile,buf,size,&dwRead,NULL);
						buf[size] = '\0';
						if(!g_s.bCapital){
							_mbslwr((UCHAR*) buf);
						}
						// ̌
						bool	flag_hit = false;
						long	len = strlen(g_s.str);
						long	char_ct = 0;
						while(char_ct < size - len + 1){
							if((buf[char_ct] == g_s.str[0])){
								if(len == 1 || (buf[char_ct+1] == g_s.str[1])){
									if(len <= 2 || (buf[char_ct+2] == g_s.str[2])){
										if(len <= 3 || !memcmp(buf+(char_ct+3), g_s.str+3, len-3)){
											flag_hit = true;
											break;
										}
									}
								}
							}
							char_ct ++;
						}
						SAFE_DELETE_ARRAY(buf);
						if(flag_hit){
							Add_Data(w32fd, filename_new, false);
						}
					}
				}
				CloseHandle(hFile);
			}
		}while(FindNextFile(hfind,&w32fd));
	}		
	FindClose(hfind);
STOP:
	// ċAJEǧZ
	g_s.numReflex --;
	if(g_s.numReflex == 0){
		Search_End();
	}
	else{
		g_s.bSearch = true;
	}
}// Search

void Search_End()
{
	g_s.bSearch = false;
	SendMessage(g_hEdit3, WM_SETTEXT, 0, (LPARAM) "");
	Draw_Info1();
}// Search_End

void Add_Data(WIN32_FIND_DATA w32fd, char *filename_new, bool bFolder)
{
	FILELIST1 fl;
	fl.bFolder = bFolder;
	strncpy(fl.Fname, filename_new, MAX_PATH);
	fl.dwFsize = w32fd.nFileSizeLow;
	FILETIME	ft = w32fd.ftLastWriteTime;
	FileTimeToLocalFileTime(&ft, &(fl.ftTime));	// EWiUTCj[J^Cɕϊ

	ZeroMemory(&(fl.stTime), sizeof(fl.stTime));
	FileTimeToSystemTime(&(fl.ftTime), &(fl.stTime));	// t@C^C`VXe^C`ɕϊ
	SHFILEINFO sfi;
	if(SHGetFileInfo(fl.Fname, 0, &sfi, sizeof(sfi), SHGFI_SYSICONINDEX | SHGFI_SMALLICON | SHGFI_TYPENAME | SHGFI_ATTRIBUTES)){
		fl.idxIcon = sfi.iIcon;
		fl.dwAttributes = sfi.dwAttributes;
		strncpy(fl.Tname, sfi.szTypeName, sizeof(fl.Tname));
	}
	Add_One_Item(fl);
	// JEg̉Z
	g_s.numItem ++;
	// \
	Draw_Info2();
}// Add_Data

// ACe̒ǉ
void Add_One_Item(FILELIST1 fl)
{
	LVITEM		lvI;
	ZeroMemory(&lvI,sizeof(lvI));
	lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	lvI.state = 0;
	if(fl.dwAttributes & SFGAO_GHOSTED){
		lvI.state |= LVIS_CUT;
	}
	if(fl.dwAttributes & SFGAO_LINK){
		lvI.state |= INDEXTOOVERLAYMASK(2);
	}
	if(fl.dwAttributes & SFGAO_SHARE){
		lvI.state |= INDEXTOOVERLAYMASK(1);
	}
	lvI.stateMask = -1;		// SĂ̏Ԃݒ
	lvI.iItem = ListView_GetItemCount(g_hList);
	lvI.iSubItem = 0;
	char *p = (char*) _mbsrchr((UCHAR*)fl.Fname, (UINT)'\\');
	if(p){
		lvI.pszText = p + 1;
	}
	LPFILELIST1 lpf = (LPFILELIST1) new FILELIST1;
	*lpf = fl;
	lvI.iImage = fl.idxIcon;
	lvI.lParam = (LPARAM)lpf;
	int index = ListView_InsertItem(g_hList, &lvI);
	
	if(index != -1){
		char str[256];
		ListView_SetItemText(g_hList,index,1,fl.Tname);
		if(!fl.bFolder){
			_snprintf(str, sizeof(str), "%9.1fKB ", (float)fl.dwFsize/1024);
			ListView_SetItemText(g_hList,index,2,str);
		}
		_snprintf(str, sizeof(str), "%04d/%02d/%02d %02d:%02d",
					fl.stTime.wYear, fl.stTime.wMonth, fl.stTime.wDay,
					fl.stTime.wHour, fl.stTime.wMinute);
		ListView_SetItemText(g_hList,index,3,str);
		ListView_SetItemText(g_hList,index,4,fl.Fname);
	}
}// Add_One_Item

// \1
void Draw_Info1()
{
	char str1[MAX_PATH + 24];
	
	if(g_s.bSearch){
		sprintf(str1,"%s",g_strRun[0]);
	}
	else{
		if(!g_s.bSearchEnd){
			sprintf(str1,"%s",g_strRun[1]);
		}
		else{
			sprintf(str1,"%s",g_strRun[2]);
		}
	}
	SendMessage(g_hStatic1, WM_SETTEXT, 0, (LPARAM) str1);
	SendMessage(g_hEdit2, WM_SETTEXT, 0, (LPARAM) g_path);
//	Draw_Info2();
}// Draw_Info1

// \2
void Draw_Info2()
{
	char str1[MAX_PATH + 24];
	sprintf(str1,"%d ", g_s.numItem);
	SendMessage(g_hStatic2, WM_SETTEXT, 0, (LPARAM) str1);
}// Draw_Info2

// ^C~O̎擾
// speed		: [IN]		x
// tick_count	: [IN][OUT]	ȑO̎
// ߂l		: true  , false  ܂
bool GetTiming(UINT speed, long *tick_count)
{
	bool flag_go = false;
	
	if(GetTickCount() - *tick_count >= speed){
		flag_go = true;
		*tick_count = GetTickCount();
	}
	return flag_go;
}// GetTiming

LPFILELIST1 Get_Lparam(int iItem)
{
	if(iItem != -1){
		LVITEM lvI;
		ZeroMemory(&lvI, sizeof(lvI));
		lvI.mask = LVIF_PARAM;
		lvI.iItem = iItem;
		if(ListView_GetItem(g_hList, &lvI)){
			LPFILELIST1 pfl = (LPFILELIST1) (lvI.lParam);
			return pfl;
		}
	}
	return NULL;
}// Get_Lparam

// \[g̔r֐ipX - j
int CharCmp_Path_Up(LPFILELIST1 a, LPFILELIST1 b)
{
	return (_mbsicmp((LPBYTE)a->Fname, (LPBYTE)b->Fname));
}// CharCmp_Path_Up
/*
// \[g̔r֐ipX - ~j
int CharCmp_Path_Down(LPFILELIST1 a, LPFILELIST1 b)
{
	return (_mbsicmp((LPBYTE)b->Fname, (LPBYTE)a->Fname));
}// CharCmp_Path_Down
*/
// \[g̔r֐it@C - j
int CharCmp_Name_Up(LPFILELIST1 a, LPFILELIST1 b)
{
	char *p1,*p2;
	p1 = (char*) _mbsrchr((UCHAR*)a->Fname, (UINT)'\\');
	p2 = (char*) _mbsrchr((UCHAR*)b->Fname, (UINT)'\\');
	if(p1 && p2){
		return (_mbsicmp((LPBYTE)p1+1, (LPBYTE)p2+1));
	}
	return (_mbsicmp((LPBYTE)a->Fname, (LPBYTE)b->Fname));
}// CharCmp_Name_Up
/*
// \[g̔r֐it@C - ~j
int CharCmp_Name_Down(LPFILELIST1 a, LPFILELIST1 b)
{
	char *p1,*p2;
	p1 = (char*) _mbsrchr((UCHAR*)a->Fname, (UINT)'\\');
	p2 = (char*) _mbsrchr((UCHAR*)b->Fname, (UINT)'\\');
	if(p1 && p2){
		return (_mbsicmp((LPBYTE)p2+1, (LPBYTE)p1+1));
	}
	return (_mbsicmp((LPBYTE)b->Fname, (LPBYTE)a->Fname));
}// CharCmp_Name_Down
*/
// \[g̔r֐igq - j
int CharCmp_Ext_Up(LPFILELIST1 a, LPFILELIST1 b)
{
	char *p,a2[MAX_PATH] = "",b2[MAX_PATH] = "";
	p = (char*) _mbsrchr((UCHAR*)(a->Fname), (UINT)'.');
	if(p){
		strncpy(a2, p+1, sizeof(a2));
	}
	p = (char*) _mbsrchr((UCHAR*)(b->Fname), (UINT)'.');
	if(p){
		strncpy(b2, p+1, sizeof(b2));
	}
	return (_mbsicmp((LPBYTE)a2, (LPBYTE)b2));
}// CharCmp_Ext_Up
/*
// \[g̔r֐igq - ~j
int CharCmp_Ext_Down(LPFILELIST1 a, LPFILELIST1 b)
{
	char *p,a2[MAX_PATH] = "",b2[MAX_PATH] = "";
	p = (char*) _mbsrchr((UCHAR*)(a->Fname), (UINT)'.');
	if(p){
		strncpy(a2, p+1, sizeof(a2));
	}
	p = (char*) _mbsrchr((UCHAR*)(b->Fname), (UINT)'.');
	if(p){
		strncpy(b2, p+1, sizeof(b2));
	}
	return (_mbsicmp((LPBYTE)b2, (LPBYTE)a2));
}// CharCmp_Ext_Down

// \[g̔r֐iXV - j
int CharCmp_Time_Up(LPFILELIST1 a, LPFILELIST1 b)
{
	return (CompareFileTime(&(a->ftTime), &(b->ftTime)));
}// CharCmp_Time_Up
*/
// \[g̔r֐iXV - ~j
int CharCmp_Time_Down(LPFILELIST1 a, LPFILELIST1 b)
{
	return (CompareFileTime(&(b->ftTime), &(a->ftTime)));
}// CharCmp_Time_Down

// \[g̔r֐it@CTCY - j
int CharCmp_Size_Up(LPFILELIST1 a, LPFILELIST1 b)
{
	return (a->dwFsize - b->dwFsize);
}// CharCmp_Size_Up
/*
// \[g̔r֐it@CTCY - ~j
int CharCmp_Size_Down(LPFILELIST1 a, LPFILELIST1 b)
{
	return (b->dwFsize - a->dwFsize);
}// CharCmp_Size_Down
*/
// Oϐ̏
void Init_Global()
{
	ZeroMemory(&g_s, sizeof(g_s));
	g_s.idxSelect = -1;
}// Init_Global

// 
void Init()
{
	int i;
	InitCommonControls();
	OleInitialize(NULL);
	// Oϐ̏
	Init_Global();
	// ^c[o[t
	g_hToolbar = Set_Tool(g_hWnd, FALSE);
	// {^TCY̎擾
	int  b_size = SendMessage(g_hToolbar, TB_GETBUTTONSIZE, 0, 0);
	// X^eBbN̍쐬
	HWND	hStatic[2] = {NULL,NULL};
	CSIZE	sz_s1,sz_s2,sz_e,sz_cb,sz_ck1,sz_ck2;
	RECT	rc_s1,rc_s2,rc_t,rc_e,rc_b,rc_cb,rc_ck1,rc_ck2;
	sz_s1 = Set_Csize(3, 0, 0, LOWORD(b_size)+4);
	hStatic[0] = Set_Static(g_hToolbar, sz_s1, "F", DEFAULT_GUI_FONT, FALSE);
	GetWindowRect(hStatic[0], &rc_s1);
	// GfBbg{bNX̍쐬
	SendMessage(g_hToolbar, TB_GETITEMRECT, 15, (LPARAM) &rc_t);
	sz_e = Set_Csize(sz_s1.x+rc_s1.right-rc_s1.left+1, 1, 200, LOWORD(b_size)+1);
	g_hEdit1 = Set_Edit(g_hToolbar, sz_e, ID_EDIT, ES_RIGHT, WS_EX_CLIENTEDGE);
	SendMessage(g_hEdit1, EM_SETLIMITTEXT, LEN, 0);
	GetWindowRect(g_hEdit1, &rc_e);
	// {^̒ǉ
	TBBUTTON	tbb[TB_NUM];
	ZeroMemory(tbb, sizeof(tbb));
	for(i=0;i<TB_NUM;i++){
		tbb[i].fsStyle = TBSTYLE_AUTOSIZE;	// {^̐ݒ (TCYݒ)
		tbb[i].fsState = TBSTATE_ENABLED;	// {^̏ԁigp\j
		tbb[i].iString = -1;				// {^̃eLXg
		tbb[i].iBitmap = g_iBmp[i];
		tbb[i].idCommand = g_iCmd[i];		// {^̖
	}
	SendMessage(g_hToolbar,TB_ADDBUTTONS,TB_NUM,(LPARAM) tbb);
	// c[o[摜̒ǉ
	TBADDBITMAP ab;
	ZeroMemory(&ab, sizeof(TBADDBITMAP));
	ab.hInst = HINST_COMMCTRL;
	ab.nID   = IDB_STD_SMALL_COLOR;
	SendMessage(g_hToolbar, TB_ADDBITMAP, 8, (LPARAM)&ab);
	// {^̃Cfg
	SendMessage(g_hToolbar, TB_SETINDENT, rc_s1.right-rc_s1.left+rc_e.right-rc_e.left+5, 0);
	// Ō̃{^ʒu̎擾	
	SendMessage(g_hToolbar, TB_GETITEMRECT, TB_NUM-1, (LPARAM)&rc_b);
	// X^eBbN̍쐬
	sz_s2 = Set_Csize(rc_b.right+5, sz_s1.y, 0, LOWORD(b_size)+4);
	hStatic[1] = Set_Static(g_hToolbar, sz_s2, "ΏہF", DEFAULT_GUI_FONT, FALSE);
	GetWindowRect(hStatic[1], &rc_s2);
	// R{{bNX̍쐬
	static char item_s[2][24] = {"̧ٖ","̧ٓ÷"};
	int item_num = sizeof(item_s)/sizeof(item_s[0]);
	int len = Get_CombLen(g_hToolbar, item_s, item_num);
	sz_cb = Set_Csize(sz_s2.x+rc_s2.right-rc_s2.left+1, LOWORD(b_size)+4, len+30, 200);
	g_hComb = Set_Combo(g_hToolbar, sz_cb);
	for(i=0; i<item_num; i++){
		SendMessage(g_hComb, CB_ADDSTRING, 0, (LPARAM) item_s[i]);
	}
	SendMessage(g_hComb, CB_SETCURSEL, 0, 0);
	GetWindowRect(g_hComb, &rc_cb);
	// `FbN{bNX̍쐬1
	sz_ck1 = Set_Csize(sz_cb.x+rc_cb.right-rc_cb.left+5, sz_s1.y, 0, LOWORD(b_size)+4);
	g_hCheck1 = Set_CheckBox(g_hToolbar, sz_ck1, "q̫ް̌");
	SendMessage(g_hCheck1, BM_SETCHECK, BST_CHECKED, 0);
	GetWindowRect(g_hCheck1, &rc_ck1);
	// `FbN{bNX̍쐬2
	sz_ck2 = Set_Csize(sz_ck1.x+rc_ck1.right-rc_ck1.left+5, sz_s1.y, 0, LOWORD(b_size)+4);
	g_hCheck2 = Set_CheckBox(g_hToolbar, sz_ck2, "E̋");
//	SendMessage(g_hCheck2, BM_SETCHECK, BST_CHECKED, 0);
	GetWindowRect(g_hCheck2, &rc_ck2);
	// Xgr[̍쐬
	g_hList = Set_ListView(g_hWnd, ID_LIST);
	// J̒ǉ
	LV_COLUMN	lvC;
	ZeroMemory(&lvC,sizeof(lvC));
	lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	for(i=0;i<COL_NUM;i++){
		lvC.iSubItem = i;
		lvC.fmt = colFmt[i];
		lvC.cx = colWdh[i];
		lvC.pszText = colText[i];
		ListView_InsertColumn(g_hList,i,&lvC);
	}
	// qEBhENX̓o^
	Set_Class_Child(MYCHILDWNDCLASS, ProcChildWnd);
	// qEBhE
	g_hChild = Set_Child(g_hWnd, MYCHILDWNDCLASS, ID_CHILD);
	// GfBbgRg[̃tbNvV[W쐬
	lpPreEditProc = (WNDPROC)SetWindowLong(g_hEdit1,GWL_WNDPROC,(LONG)ProcEdit);
/*	// JghCu̐ݒ
	GetCurrentDirectory(sizeof(g_path), g_path);
	char *p1 = strchr(g_path, '\\');
	if(p1){
		strcpy(p1, "");
	}
*/	// tH_[w_CAO̕\
	if(!M_Dir(g_hWnd)){
		SendMessage(g_hWnd,WM_CLOSE,0,0);
	}
	// ݒǂݍ
	char strIni[MAX_PATH],*p2;
	GetModuleFileName(NULL,strIni,sizeof(strIni));
	p2 = strrchr(strIni,'.');
	if(p2){
		strcpy(p2,".ini");
	}
	GetPrivateProfileString(MYWNDTITLE,"DEFAULT_EXE","notepad",g_s.strExe,sizeof(g_s.strExe),strIni);
}// Init

// ẴACẽ[̉
void Memory_AllFree()
{
	int i,num = ListView_GetItemCount(g_hList);
	for(i=0;i<num;i++){
		LPFILELIST1 pfl = Get_Lparam(i);
		SAFE_DELETE_OBJ(pfl);
	}
}// Memory_AllFree

// I
void Term()
{
	Memory_AllFree();
	if(g_hIml){
		ImageList_Destroy(g_hIml);
	}
	OleUninitialize();
}// Term
