#ifndef __SETWIN2_H__
#define __SETWIN2_H__

// Child		1524 `
// Tool			1572 `
// Combo		1588 `
// Static		1652 `
// Static2		1676 `
// CheckBox		1716 `

// Rg[̈ʒuƃTCY
typedef struct{
	int x,y,wdh,hgt;
}CSIZE,*LPCSIZE;

void	Set_Class_Child(char *cls, WNDPROC ProcWnd);
HWND	Set_Child(HWND hWnd, char *class_name, UINT id_child);
HWND	Set_Tool(HWND hWnd, bool flag_Vert);
HWND	Set_Static(HWND hParent, CSIZE sz, char *text, bool flag_Vert);
HWND	Set_Static2(HWND hParent, CSIZE sz, char *text, int fnt_obj);
HWND	Set_Edit(HWND hParent, CSIZE sz, UINT id_edit, UINT style, UINT styleEx);
HWND	Set_CheckBox(HWND hParent, CSIZE sz, char *text);
HWND	Set_ListView(HWND hParent, UINT id_list);
HWND	Set_Combo(HWND hParent, CSIZE sz);
int		Get_CombLen(HWND hParent, char (*item_s)[24], int item_num);
CSIZE	Set_Csize(int x, int y, int wdh, int hgt);
SIZE	Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str);
SIZE	Get_StrSize(HWND hWnd, char *str);
bool	Menu_Toggle_Check(HMENU hMenu, UINT ID);
void	Menu_Add_Item(HMENU hMenu, UINT ID, char *string, UINT index);
//int		Get_IdxMenuFromString(HMENU hMenu, char *strMenuItem);

// qEBhENX̓o^
void Set_Class_Child(char *cls, WNDPROC ProcWnd)
{
	WNDCLASSEX wc;
	
	// qEBhE
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= GetModuleHandle(NULL);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE+1);
	wc.style			= CS_DBLCLKS;
	wc.lpszClassName	= cls;
	RegisterClassEx(&wc);
	
}// Set_Class_Child

// qEBhE̍쐬
HWND Set_Child(HWND hWnd, char *class_name, UINT id_child)
{
	HWND hChild = CreateWindowEx(0,
					class_name, NULL,
					WS_CHILD | WS_VISIBLE,
					0, 0, 0, 0, hWnd, (HMENU) id_child, GetModuleHandle(NULL), NULL);
	return (hChild);
}// Set_Child

// c[o[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Tool(HWND hWnd, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = CCS_VERT;
	}
	else{
		style = 0;
	}
	static int k = 0;
	HWND hTool = CreateWindowEx(0,
								TOOLBARCLASSNAME,
								NULL,
								WS_CHILD | 
								WS_CLIPCHILDREN | 
								WS_VISIBLE | 
								WS_BORDER | 
								TBSTYLE_TOOLTIPS | 
								style,
								0,0,0,0,
								hWnd,
								(HMENU) 1572 + k++,
								GetModuleHandle(NULL),
								NULL);
	SendMessage(hTool, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
	return (hTool);
}// Set_Tool

// X^eBbNRg[̍쐬
// hParent		: [IN] eEBhẼnh
// sz			: [IN] Rg[̃TCY
// text			: [IN] \
// fnt_obj		: [IN] tHg̃XgbNIuWFNg
// flag_Vert	: [IN] false - ^Atru - c^
HWND Set_Static(HWND hParent, CSIZE sz, char *text, int fnt_obj, bool flag_Vert)
{
	CSIZE sz_st;
	if(flag_Vert){
		sz_st = Set_Csize(sz.y, sz.x, sz.hgt, 0);
	}
	else{
		sz_st = Set_Csize(sz.x, sz.y, 0, sz.hgt);
	}

	static int k = 0;
	HWND hStatic = CreateWindowEx(0,
								"STATIC",
								text,
								SS_LEFT | WS_CHILD | WS_VISIBLE,
								0, 0, 0, 0,
								hParent,
								(HMENU) 1652 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(fnt_obj);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj)
		SendMessage(hStatic, WM_SETFONT, (WPARAM) sobj, MAKELPARAM(TRUE, 0));
	// \ʒu̐ݒ
	if(sobj){
		SIZE size;
		size = Get_StrSize(hStatic, sobj, text);
		if(flag_Vert){
			sz_st.x = (sz_st.wdh - size.cx) / 2;
			if(sz_st.x < 0)	sz_st.x = 0;
		}
		else{
			sz_st.y += (sz_st.hgt - size.cy) / 2;
			if(sz_st.y < 0)	sz_st.y = 0;
		}
		MoveWindow(hStatic, sz_st.x, sz_st.y, size.cx, size.cy, FALSE);
	}
	
	return (hStatic);
}// Set_Static

HWND Set_Static2(HWND hParent, CSIZE sz, char *text, int fnt_obj)
{
	static int k = 0;
	HWND hStatic = CreateWindowEx(0,
								"STATIC",
								text,
								SS_LEFT | WS_CHILD | WS_VISIBLE,
								sz.x, sz.y, sz.wdh, sz.hgt,
								hParent,
								(HMENU) 1652 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(fnt_obj);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj)
		SendMessage(hStatic, WM_SETFONT, (WPARAM) sobj, MAKELPARAM(TRUE, 0));
	
	return (hStatic);
}// Set_Static2

// GfBbg̍쐬
// flag_VertFc^  1A^  0
HWND Set_Edit(HWND hParent, CSIZE sz, UINT id_edit, UINT style, UINT styleEx)
{
	HWND hEdit = CreateWindowEx(styleEx,
				"EDIT",
				NULL,
				WS_CHILD | WS_TABSTOP | WS_VISIBLE | style,
				sz.x, sz.y, sz.wdh, sz.hgt,
				hParent,
				(HMENU) id_edit,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hEdit, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
	}
	
	return (hEdit);
}// Set_Edit

// `FbN{bNX̍쐬
HWND Set_CheckBox(HWND hParent, CSIZE sz, char *text)
{
	static int k = 0;
	HWND hCheck = CreateWindowEx(0,
				"BUTTON",
				text,
				WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX | BS_VCENTER,
				0, 0, 0, 0,
				hParent,
				(HMENU) 1716 + k++,
				GetModuleHandle(NULL),
				NULL);
	
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL)
		SendMessage(hCheck, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
	// \ʒu̐ݒ
	if(sobj){
		SIZE size;
		size = Get_StrSize(hCheck, sobj, text);
		sz.y = (sz.hgt - size.cy) / 2;
		if(sz.y < 0)	sz.y = 0;
		MoveWindow(hCheck, sz.x, sz.y, size.cx+20, size.cy, FALSE);
	}
	
	return (hCheck);
}// Set_CheckBox

// Xgr[̍쐬
HWND Set_ListView(HWND hParent, UINT id_list)
{
	HWND hList = CreateWindowEx(WS_EX_CLIENTEDGE, 
								WC_LISTVIEW,
								NULL,
								WS_CHILD | WS_TABSTOP | WS_VISIBLE | LVS_REPORT |
								LVS_SHOWSELALWAYS | LVS_EDITLABELS,
								0, 0, 0, 0,
								hParent,
								(HMENU) id_list,
								GetModuleHandle(NULL),
								NULL);
	return (hList);
}// Set_ListView

// R{{bNX̍쐬
HWND Set_Combo(HWND hParent, CSIZE sz)
{
	static int k = 0;
	HWND hComb = CreateWindowEx(0,
								"COMBOBOX",
								NULL,
								WS_CHILD | WS_TABSTOP | WS_VISIBLE | CBS_DROPDOWNLIST | WS_VSCROLL,
								sz.x, sz.y, sz.wdh, sz.hgt,
								hParent,
								(HMENU) 1588 + k++,
								GetModuleHandle(NULL),
								NULL);
	// tHg̐ݒ
	HGDIOBJ 	sobj = NULL;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(sobj == NULL)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj != NULL){
		SendMessage(hComb, WM_SETFONT, (WPARAM)sobj, MAKELPARAM(TRUE, 0));
		DeleteObject(sobj);
	}
	// EBhẼTCYύX
	RECT rc;
	GetWindowRect(hComb, &rc);
	int hgt = (sz.y - (rc.bottom - rc.top)) / 2;
	MoveWindow(hComb, sz.x, hgt, sz.wdh, sz.hgt, FALSE);
	return (hComb);
}// Set_Combo

// eR{{bNX̃ACe̍ő啝
int Get_CombLen(HWND hParent, char (*item_s)[24], int item_num)
{
	HGDIOBJ 	sobj = NULL;
	SIZE		size;
	int			max = 0;
	sobj = GetStockObject(DEFAULT_GUI_FONT);
	if(!sobj)
		sobj = GetStockObject(ANSI_VAR_FONT);
	if(sobj){
		for(int i=0; i<item_num; i++){
			size = Get_StrSize(hParent, sobj, item_s[i]);
			if(size.cx > max)
				max = size.cx;
		}
	}
	return max;
}// Get_CombLen

CSIZE Set_Csize(int x, int y, int wdh, int hgt)
{
	CSIZE sz;
	sz.x   = x;
	sz.y   = y;
	sz.wdh = wdh;
	sz.hgt = hgt;
	return sz;
}// Set_Csize

SIZE Get_StrSize(HWND hWnd, HGDIOBJ sobj, char *str)
{
	HGDIOBJ sobj_pre;
	SIZE    size;
	HDC hDC = GetDC(hWnd);
	sobj_pre = SelectObject(hDC, sobj);
	GetTextExtentPoint32(hDC, str, strlen(str), &size);
	SelectObject(hDC, sobj_pre);
	DeleteObject(sobj);
	ReleaseDC(hWnd, hDC);
	return (size);
}// Get_StrSize

SIZE Get_StrSize(HWND hWnd, char *str)
{
	SIZE    size;
	HDC hDC = GetDC(hWnd);
	GetTextExtentPoint32(hDC, str, strlen(str), &size);
	ReleaseDC(hWnd, hDC);
	return (size);
}// Get_StrSize

// j[̃`FbNύX
bool Menu_Toggle_Check(HMENU hMenu, UINT ID)
{
	MENUITEMINFO    mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	GetMenuItemInfo(hMenu,ID,0,&mi);
	
	if(mi.fState == MFS_UNCHECKED)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);

	if(mi.fState == MFS_UNCHECKED)
		return 0;
	return 1;
}// Menu_Toggle_Check

void Menu_Add_Item(HMENU hMenu, UINT ID, char *string, UINT index)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize		= sizeof(mi);
	mi.fMask		= MIIM_ID | MIIM_TYPE | MIIM_STATE;
	mi.wID			= ID;
	mi.fType		= MFT_STRING;
	mi.fState		= MFS_ENABLED;
	mi.dwTypeData	= string;
	InsertMenuItem(hMenu, index, TRUE, &mi);
}// Menu_Add_Item
/*
// j[ACe񂩂ACeԍ擾
// hMenu		: [IN] j[̃nh
// strMenuItem	: [IN] ̑ΏۂƂȂACeij
// ߂l		: ACeԍi݂Ȃꍇ́A-1j
int Get_IdxMenuFromString(HMENU hMenu, char *strMenuItem)
{
	int		idxMenu = -1;
	int		numMenu = GetMenuItemCount(hMenu);
	char	strMenuItem2[256];
	
	for(int i=0;i<numMenu;i++){
		GetMenuString(hMenu, i, strMenuItem2, sizeof(strMenuItem2), MF_BYPOSITION);
		if(strstr(strMenuItem2, strMenuItem)){
			idxMenu = i;
			break;
		}
	}
	return idxMenu;
}// Get_IdxMenuFromString
*/
#endif // __SETWIN2_H__
